@echo off
if "%OS%" == "Windows_NT" setlocal
rem ---------------------------------------------------------------------------
rem NT Service Install/Uninstall script
rem
rem Options
rem install                Install the service using Tomcat5 as service name.
rem                        Service is installed using default settings.
rem remove                 Remove the service from the System.
rem
rem name        (optional) If the second argument is present it is considered
rem                        to be new service name                                           
rem
rem $Id: service.bat 414655 2006-06-15 18:56:42Z yoavs $
rem ---------------------------------------------------------------------------

rem Guess CATALINA_HOME if not defined
set CURRENT_DIR=%cd%
set JAVA_HOME=%CURRENT_DIR%\jre

rem Convert the current working directory
rem to a format that is valid for use in a
rem a file URL
set CUR_PATH=%cd%
set DRIVE=%cd:~0,1%
set SHORT_PATH=%~sp0%
set SHORT_PATH=%SHORT_PATH:\=/%
set PATH_URL=%DRIVE%%%3a%SHORT_PATH%

:modify teamserver.properties file
@echo off
setlocal enabledelayedexpansion

SET CURRENT_DIR=%cd%
SET CURRENT_DIR_REVERT=%CURRENT_DIR:\=/%
SET FILE_DIR=%CURRENT_DIR%\conf\jazz
CD %FILE_DIR%

SET REPLACED_DB_DIR="com.ibm.team.repository.db.jdbc.location=repositoryDB"
SET REPLACED_INDEX_DIR="com.ibm.team.fulltext.indexLocation=workitemindex"

SET REPLACEWITH_DB_DIR=com.ibm.team.repository.db.jdbc.location=%CURRENT_DIR_REVERT%/repositoryDB
SET REPLACEWITH_INDEX_DIR=com.ibm.team.fulltext.indexLocation=%CURRENT_DIR_REVERT%/workitemindex

FOR /F "usebackq delims=" %%i IN ("teamserver.properties") DO (
  SET "line=%%i"  
  IF "!line!"==!REPLACED_DB_DIR! SET line=!REPLACEWITH_DB_DIR!
  IF "!line!"==!REPLACED_INDEX_DIR! SET line=!REPLACEWITH_INDEX_DIR!
  ECHO !line!>>"teamserver.properties.backup"
)
  DEL teamserver.properties
 FOR /F "usebackq delims=" %%i IN ("teamserver.properties.backup") DO (
  SET "line=%%i"  
  ECHO !line!>>"teamserver.properties"
 )
  DEL teamserver.properties.backup

if not "%CATALINA_HOME%" == "" goto gotHome
set CATALINA_HOME=%CURRENT_DIR%\tomcat
if exist "%CATALINA_HOME%\bin\tomcat5.exe" goto okHome
:gotHome
if exist "%CATALINA_HOME%\bin\tomcat5.exe" goto okHome
echo The tomcat.exe was not found...
echo The CATALINA_HOME environment variable is not defined correctly.
echo This environment variable is needed to run this program
goto end
rem Make sure prerequisite environment variables are set
if not "%JAVA_HOME%" == "" goto okHome
echo The JAVA_HOME environment variable is not defined
echo This environment variable is needed to run this program
goto end 
:okHome
if not "%CATALINA_BASE%" == "" goto gotBase
set CATALINA_BASE=%CATALINA_HOME%
:gotBase
 
set EXECUTABLE=%CATALINA_HOME%\bin\tomcat5.exe

rem Set default Service name
set SERVICE_NAME=RQM
set PR_DISPLAYNAME=IBM Rational Quality Manager

if "%1" == "" goto displayUsage
if "%2" == "" goto setServiceName
set PR_DISPLAYNAME=%PR_DISPLAYNAME% %2
:setServiceName
if %1 == install goto doInstall
if %1 == remove goto doRemove
if %1 == uninstall goto doRemove
echo Unknown parameter "%1"
:displayUsage
echo.
echo Usage: rqm.service.bat install/remove [server_version]
echo.
    echo example: rqm.service.bat install 2.0.1
goto end

:doRemove
rem Remove the service
"%EXECUTABLE%" //DS//%SERVICE_NAME%
echo The service '%SERVICE_NAME%' has been removed
goto end

:doInstall
rem Install the service
echo Installing the service '%SERVICE_NAME%' ...
echo Using CATALINA_HOME:    %CATALINA_HOME%
echo Using CATALINA_BASE:    %CATALINA_BASE%
echo Using JAVA_HOME:        %JAVA_HOME%
echo using CONFIGURE_DIR:    file:///%PATH_URL%conf
echo using TEMP:			 %TEMP%

rem Use the environment variables as an example
rem Each command line option is prefixed with PR_

set PR_DESCRIPTION=%PR_DISPLAYNAME%
set PR_INSTALL=%EXECUTABLE%
set PR_LOGPATH=%CATALINA_BASE%\logs
set PR_CLASSPATH=%CATALINA_HOME%\bin\bootstrap.jar

rem Set the server jvm from JRE of RQM
set PR_JVM=%CURRENT_DIR%\jre\bin\j9vm\jvm.dll
if exist "%PR_JVM%" goto foundJvm
rem Set the client jvm from JAVA_HOME
set PR_JVM=%JAVA_HOME%\jre\bin\client\jvm.dll
if exist "%PR_JVM%" goto foundJvm
rem Check for JRockit JVM: Bugzilla 39674
set PR_JVM=%JAVA_HOME%\jre\bin\jrockit\jvm.dll
if exist "%PR_JVM%" goto foundJvm
set PR_JVM=auto

:foundJvm
echo Using JVM:              %PR_JVM%
"%EXECUTABLE%" //IS//%SERVICE_NAME% --DisplayName="%PR_DISPLAYNAME%" --Startup=auto --StartClass org.apache.catalina.startup.Bootstrap --StopClass org.apache.catalina.startup.Bootstrap --StartParams start --StopParams stop
if not errorlevel 1 goto installed
echo Failed installing '%SERVICE_NAME%' service
goto end
:installed
rem Clear the environment variables. They are not needed any more.
set PR_DISPLAYNAME=
set PR_DESCRIPTION=
set PR_INSTALL=
set PR_LOGPATH=
set PR_CLASSPATH=
set PR_JVM=
rem Set extra parameters
set SERVER=%CURRENT_DIR%
echo %SERVER%
CD %CURRENT_DIR%
"%EXECUTABLE%" //US//%SERVICE_NAME% --Jvm="%SERVER%\jre\bin\j9vm\jvm.dll"
"%EXECUTABLE%" //US//%SERVICE_NAME% --JvmOptions "-Dcatalina.base=%CATALINA_BASE%;-Dcatalina.home=%CATALINA_HOME%;-Djava.endorsed.dirs=%CATALINA_HOME%\common\endorsed" --StartMode jvm --StopMode jvm
rem More extra parameters
set PR_LOGPATH=%CATALINA_BASE%\logs
set PR_STDOUTPUT=auto
set PR_STDERROR=auto
"%EXECUTABLE%" //US//%SERVICE_NAME% ++JvmOptions "-Djava.awt.headless=true;-Dorg.eclipse.emf.ecore.plugin.EcorePlugin.doNotLoadResourcesPlugin=true;-DJAZZ_HOME=file:///%PATH_URL%conf;-Dcom.ibm.team.repository.tempDir=%TEMP%" --JvmMs 128 --JvmMx 700
echo The service '%SERVICE_NAME%' has been installed.

:end
cd %CURRENT_DIR%
